#include "GestionnaireDeVerrou.h"
#include "Mutex.h"
#include "Autoverrou.h"

GestionnaireDeVerrou GestionnaireDeVerrou::Singleton;

GestionnaireDeVerrou::GestionnaireDeVerrou()
   : m_CptVerrou (0), m_Mutex (new Mutex ())
{
}

void GestionnaireDeVerrou::Incrementer()
{
   Autoverrou a(*m_Mutex);
   m_CptVerrou++;
}

void GestionnaireDeVerrou::Decrementer()
{
   Autoverrou a(*m_Mutex);
   m_CptVerrou--;
}

bool GestionnaireDeVerrou::EstVide() const
{
   return m_CptVerrou == 0;
}

GestionnaireDeVerrou::~GestionnaireDeVerrou()
{
   delete m_Mutex;
}
